#!/bin/sh
#########################################################################
# Shell-Script zum Suchen in den elektronischen Inhaltsverzeichnissen der 
# Heise-Zeitschriften per WWW-Server
# Volker Ossenkopf, Koeln -- 11.7.2000
#########################################################################
# Version fuer die c't 
# (bei iX muessen die Variablen auf ix und <i>iX</i> gesetzt werden)
SNAME='ct'; FNAME="c't"

# Path aller ausfuehrbaren Dateien im Script: 
# cat, expr, sed, awk, cut, cgiparse, agrep muessen gefunden werden
# Die Vermeidung ueberfluessiger Eintraege erschwert Hacks
PATH=/bin:/usr/bin:/usr/local/bin:/usr/lib/cgi-bin

# Directory in dem die Datenfiles ct90.dat - ct99.dat stehen
DIR=/home/www/ct/

# Gewuenschte Zugriffsart auf die gefundenen Artikel 
# entweder "file:" oder "http://www-hostname"
ACCESS='file:'

# Einfach-CD-Laufwerk oder CD-Wechsler bzw. mehrere Mountpunkte
# fuer die Jahres-CDs: 'single_cd_drive' or 'multi_cd_drive'
DRIVE='single_cd_drive'

# Bei DRIVE='single_cd_drive' Angaben fuer alles CDs: 
# Name des Directories, an das das html-Directory der CD-ROMs 
# gemountet oder gelinkt wird, bei ACCESS='file:' absolut, bei 
# ACCESS='http://www-hostname' relativ zu DocumentRoot
CDROM=/home/www-data/ct/cdrom/

# Bei DRIVE='multi_cd_drive' Angaben fuer einzelne Jahres-CDs:
# (Bei 'single_cd_drive' werden die folgenden Eintraege ignoriert.)
# Name der Directories, an die das html-Directory der CD-ROMs 
# gemountet oder gelinkt wird, bei ACCESS='file:' absolut, bei 
# ACCESS='http://www-hostname' relativ zu DocumentRoot
# CD-ROM 90/91
CDROM91=/home/www-data/ct/cdrom/
# CD-ROM 92/93
CDROM93=/home/www-data/ct/cdrom/
# CD-ROM 94
CDROM94=/home/www-data/ct/cdrom/
# CD-ROM 95
CDROM95=/home/www-data/ct/cdrom/
# CD-ROM 96
CDROM96=/home/www-data/ct/cdrom/
# CD-ROM 97
CDROM97=/home/www-data/ct/cdrom/
# CD-ROM 98
CDROM98=/home/www-data/ct/cdrom/
# CD-ROM 99
CDROM99=/home/www-data/ct/cdrom/
# CD-ROM 00
CDROM00=/home/www-data/ct/cdrom/

# Name des System V/R4-awk-Befehls: i.a. awk oder gawk, unter SUN-OS
# und Solaris aber nawk
AWK=awk

#########################################################################
# Ab hier sind keine Anpassungen durch den Nutzer mehr noetig !
#########################################################################

# Jahresvariablen bei single_cd_drive belegen
if [ "${DRIVE}" = "single_cd_drive" ]
then
eval `for i in 91 93 94 95 96 97 98 99 00
do echo CDROM${i}=${CDROM}';' ; done`
fi

# Header produzieren
echo 'Content-type: text/html'
echo ''

# Parameter aus dem QUERY_STRING extrahieren
eval `cgiparse -form`

# Test for cgiparse and reasonable input
if [ "${FORM_cases}" != 'nicht beachten' -a "${FORM_cases}" != 'beachten' ]
then 
echo "Der Query-String konnte durch cgiparse nicht korrekt ausgewertet werden.<p>"
echo "berprfen Sie die Installation von cgiparse und die Eingabemaske."
exit 1
fi

# HTML Header
cat << !!
<HTML> <HEAD>
<TITLE>Ergebnis der ${SNAME}-Archiv-Suche</TITLE>
</HEAD> <BODY>
<p><H1 align=center>Suchergebnis: &#32;
!!

# Optionen fuer agrep entsprechend der Parameter
ENO=`echo "${FORM_fuzzy}" | sed -e 's/[^0-9]/0/g'`
PAR="-${ENO}"

case "$FORM_cases" in
nicht?beachten) PAR=$PAR' -i';;
esac

case "$FORM_words" in
ganze?Worte) PAR=$PAR' -w';;
esac

#Logische Verknuepfung auswerten, Leerzeichen entsprechend ersetzen
case "${FORM_relat}" in
String)   EXPR=`echo "${FORM_suchwort}" |sed 's/ *$//'`
          WEXPR="${FORM_suchwort}" ;;
AND)      EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */;/g'` 
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \& /g'` ;;
OR)       EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */,/g'` 
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \| /g'` ;;
esac

# Ausgabe des Suchwortes im Kopf
echo "${WEXPR} </h1>"

# Anzahlbegrenzung ermitteln
if ANZ=`expr "${FORM_anzahl}" - 0 2>/dev/null`; then ANZ=$ANZ; else ANZ=1000; fi

# Sortierrichtung
case "${FORM_richtung}" in
aufsteigend) SPAR='-b' ;;
absteigend) SPAR='-r' ;;
esac

# Spaltennummern finden fuer Werte die per feld gegeben wurden
# Datenformat der dat-Dateien der CDROMs (Trenner = '|')
# 1: Titel, 2: Untertitel, 3: Zeitschrift, 4: Jahr, 5: Monat, 6: Seite
# 7: Autor, 8: Erfassungsdatum, 9: ISBN, 10: Filename, 11: Rubrik+Schlagworte
FIELDS=' -f '
if echo "${FORM_feld}" |fgrep -e Titel >/dev/null; then FIELDS=${FIELDS}'1,' ; fi
if echo "${FORM_feld}" |fgrep -e Untertitel >/dev/null; then FIELDS=${FIELDS}'2,' ; fi
if echo "${FORM_feld}" |fgrep -e Rubrik >/dev/null; then FIELDS=${FIELDS}'11,' ; fi
if echo "${FORM_feld}" |fgrep -e Schlagworte >/dev/null; then FIELDS=${FIELDS}'12,' ; fi
if echo "${FORM_feld}" |fgrep -e Autor >/dev/null; then FIELDS=${FIELDS}'7,' ; fi
if echo "${FORM_feld}" |fgrep -e Jahr >/dev/null; then FIELDS=${FIELDS}'4,' ; fi
if echo "${FORM_feld}" |fgrep -e Monat >/dev/null; then FIELDS=${FIELDS}'5,' ; fi
if echo "${FORM_feld}" |fgrep -e Seite >/dev/null; then FIELDS=${FIELDS}'6,' ; fi
FIELDS=${FIELDS}'8'

# Monate numerisch machen, Jahre aus Parametern bestimmen
# Sicherstellen, dass kein Hack ueber $DAT moeglich wird
M1=`echo "${FORM_monat1}" | sed -e 's/[^0-9]/0/g'`
M2=`echo "${FORM_monat2}" | sed -e 's/[^0-9]/0/g'`
if J1=`expr "${FORM_jahr1}" - 0`; then J0=$J1;
else echo "${FORM_jahr1}"' ist nichtnumerisch </body></html>'; exit ; fi
if J2=`expr "${FORM_jahr2}" - 0`; then echo '<hr>';
else echo "${FORM_jahr2}"' ist nichtnumerisch </body></html>'; exit ; fi

# Schleife fuer Jahre
while test $J1 -le $J2 
do 
SJ1=`echo ${J1} | cut -c '3,4'`
DAT=${SNAME}${SJ1}'.dat' 

# Directories auswaehlen
case $J1 in
1990|1991) CDROM=${CDROM91}${SJ1}/ ;;
1992|1993) CDROM=${CDROM93}${SJ1}/ ;;
1994) CDROM=${CDROM94} ;;
1995) CDROM=${CDROM95}${SJ1}/ ;;
1996) CDROM=${CDROM96}${SJ1}/ ;;
1997) CDROM=${CDROM97}${SJ1}/ ;;
1998) CDROM=${CDROM98}${SJ1}/ ;;
1999) CDROM=${CDROM99}${SJ1}/ ;;
*) CDROM=${CDROM00}${SJ1}/ ;;
esac

# Monatsbedingung fuer das jeweilige Jahr formulieren
if test $J0 -eq $J2; then COND='$5 >= '$M1' && $5 <= '$M2; 
elif test $J1 -eq $J0; then COND='$5 >= '$M1; 
elif test $J1 -eq $J2; then COND='$5 <= '$M2;
else COND='';
fi

# Zweistufige Reduktion mit awk und sed
#     - Monatsbegrenzung beruecksichtigen
#     - Felder ausschneiden, 
#     - mit agrep Suchworte finden,
#     - Zeilennummern an sed uebergeben 
#     - Pfad mit uebergeben -> alle Eintragsnummern wachsen um 1
# ( agrep mit -n macht oft Mist -> Zeilennummern vorher mit nl erzeugen )
$AWK -F"|" "${COND}"' {gsub("'"${SJ1}"'","'"${J1}"'",$4)
 if ( NF==11 ) { sub(",",":",$11); sub(",","|",$11) 
 printf("'${CDROM}'|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11) }
 else printf("'${CDROM}'|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12) 
 } ' ${DIR}${DAT} 2>/dev/null |\
sed -n `$AWK -F"|" "${COND}"' {if ( NF==11 ) { sub(",",":",$11); sub(",","|",$11) 
 printf("%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11) }
 else printf("%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12) 
 } ' ${DIR}${DAT} 2>/dev/null |\
cut -d"|" $FIELDS |\
nl -ba -p | agrep $PAR -e "${EXPR}" 2>/dev/null |\
sed -e 's/^ */-e /' -e 's/\	.*$/p /'` 2>/dev/null 
# sed -e 's/^ */-e /' -e 's/\	.*$/p /'|head -n 99 ` 2>/dev/null
# DEC und HP sed koennen nur 99 Kommandos. Falls dieses verwendet werden
# soll, muss die Zeile mit 'head -n 99' statt der vorhergehenden benutzt
# werden.

J1=`expr $J1 + 1`
done |\

# Ende der Jahresschleife
# Nachverarbeitung des gesamten Ergebnisstromes
#     - Sortieren,
#     - Uebergabebegrenzung beruecksichtigen,
#     - Daten fuer die Ausgabe formatieren
sort "${SPAR}" -t'|' +4 -7 |\
$AWK -F"|" 'NR <= '"${ANZ}"' { gsub(", *,*$"," :",$12);
	    printf("<p><i>%s</i></p>\n",$12);
	    printf("<h3>%s</h3>", $2);
	    printf("<h4>%s</h4>", $3);
	    nn = split($8, NOM, "/");
	    if ( NOM[1] != "" ) printf("<p>%s, <kbd>%s</kbd></p>\n", NOM[1],NOM[2]);
	    else printf("\n");
	    gsub("'${SNAME}'","'${FNAME}'",$4);
	    printf("<p><A HREF=\"'${ACCESS}'%s%02d/%03d/%s\">",$1,$6,$7,$11);
	    printf("%s %s, Heft %d, Seite %d</A></p>\n", $4, $5, $6, $7);
	    printf("<p>%s</p>\n",$13);
	    printf("<HR>\n") } 
	    END { if ( NR == 0 ) { printf("<p><b>Keine Eintr&auml;ge gefunden.</b><p><hr>\n");
                                   printf("<h2 align=center>Suche nach &auml;hnlichen Begriffen:</h2><hr><p>\n");
                                  exit 1 }
                printf("<h2 align=center>Insgesamt %d Artikel in '${FNAME}' '$M1'/'$J1' - '$M2'/'$J2' gefunden.</h2><hr>\n",NR) } 
	   '

# Weitere Durchlaeufe mit toleranteren Kriterien, wenn nichts gefunden wurde
FOUND=$?
while [ '(' $FOUND -ne 0 ')' -a  '(' $ENO -le 3 ')' ] 
do
PAR="-i -$ENO"
ENO=`expr "${ENO}" + 1`

# Die gesamte Prozedur von oben wird hier mit relaxten Parametern wiederholt
J1=`expr "${FORM_jahr1}" - 0`
while test $J1 -le $J2 
do 
SJ1=`echo ${J1} | cut -c '3,4'`
DAT=${SNAME}${SJ1}'.dat' 
case $J1 in
1990|1991) CDROM=${CDROM91}${SJ1}/ ;;
1992|1993) CDROM=${CDROM93}${SJ1}/ ;;
1994) CDROM=${CDROM94} ;;
1995) CDROM=${CDROM95}${SJ1}/ ;;
1996) CDROM=${CDROM96}${SJ1}/ ;;
1997) CDROM=${CDROM97}${SJ1}/ ;;
1998) CDROM=${CDROM98}${SJ1}/ ;;
1999) CDROM=${CDROM99}${SJ1}/ ;;
*) CDROM=${CDROM00}${SJ1}/ ;;
esac
if test $J0 -eq $J2; then COND='$5 >= '$M1' && $5 <= '$M2; 
elif test $J1 -eq $J0; then COND='$5 >= '$M1; 
elif test $J1 -eq $J2; then COND='$5 <= '$M2;
else COND='';
fi
$AWK -F"|" "${COND}"' {gsub("'"${SJ1}"'","'"${J1}"'",$4)
 if ( NF==11 ) { sub(",",":",$11); sub(",","|",$11) 
 printf("'${CDROM}'|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11) }
 else printf("'${CDROM}'|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12) 
 } ' ${DIR}${DAT} 2>/dev/null |\
sed -n `$AWK -F"|" "${COND}"' {if ( NF==11 ) { sub(",",":",$11); sub(",","|",$11) 
 printf("%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11) }
 else printf("%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12) 
 } ' ${DIR}${DAT} 2>/dev/null |\
cut -d"|" $FIELDS |\
nl -ba -p | agrep $PAR -e "${EXPR}" 2>/dev/null |\
sed -e 's/^ */-e /' -e 's/\	.*$/p /'` 2>/dev/null
# sed -e 's/^ */-e /' -e 's/\	.*$/p /'|head -n 99 ` 2>/dev/null
J1=`expr $J1 + 1`
done |\
sort "${SPAR}" -t'|' +4 -7 |\
$AWK -F"|" 'NR <= '"${ANZ}"' { gsub(", *,*$"," :",$12);
	    printf("<p><i>%s</i></p>\n",$12);
	    printf("<h3>%s</h3>", $2);
	    printf("<h4>%s</h4>", $3);
	    nn = split($8, NOM, "/");
	    if ( NOM[1] != "" ) printf("<p>%s, <kbd>%s</kbd></p>\n", NOM[1],NOM[2]);
	    else printf("\n");
	    gsub("'${SNAME}'","'${FNAME}'",$4);
	    printf("<p><A HREF=\"'${ACCESS}'%s%02d/%03d/%s\">",$1,$6,$7,$11);
	    printf("%s %s, Heft %d, Seite %d</A></p>\n", $4, $5, $6, $7);
	    printf("<p>%s</p>\n",$13);
	    printf("<HR>\n") } 
	    END { if ( NR == 0 ) exit 1
                printf("<h2 align=center>Insgesamt %d Artikel in '${FNAME}' '$M1'/'$J1' - '$M2'/'$J2' gefunden.</h2><hr>\n",NR) } 
	   '
FOUND=$?
done

# Schlussausgabe, falls keine Eintraege gefunden wurden
if [ $FOUND -ne 0 ]
then
echo "<b>Keine Eintrge gefunden</b><p><hr>"
echo "<h2 align=center>Keine Fundstellen in ${FNAME} ${M1}/${J1} - ${M2}/${J2}.</h2><hr>"
fi

# Kontrollausgabe der Input-Parameter
echo "<strong>Benutzte Parameter:</strong> Gro/Kleinschreibung ${FORM_cases}, bereinstimmung: ${FORM_words}, ${FORM_fuzzy} Fehler, Wortverknpfung: ${FORM_relat},"
echo "Suchfelder: ${FORM_feld}, Fundstellenausgabe: ${FORM_anzahl}, ${FORM_richtung} sortiert.<hr>"

echo "</BODY></HTML>"
# Das wars schon.

