#!/bin/sh
#########################################################################
# Shell-Script zur Volltextsuche in einzelnen Heften der CD-ROM-Versionen
# der Zeitschriften des Heise-Verlages
# Volker Ossenkopf, Kln - 5.10.2000
#########################################################################
# Version fuer die c't 
# (bei iX muessen die Variablen auf ix und <i>iX</i> gesetzt werden)
SNAME='ct'; FNAME="c't"

# Path aller ausfuehrbaren Dateien im Script: 
# sed, awk, cgiparse, agrep und eventuell glimpse muessen gefunden werden
PATH=/bin:/usr/bin:/usr/local/bin:/usr/lib/cgi-bin

# Gewuenschte Zugriffsart auf die gefundenen Artikel 
# entweder "file:" oder "http://www-hostname"
ACCESS='file:'

# Einfach-CD-Laufwerk oder CD-Wechsler bzw. mehrere Mountpunkte
# fuer die Jahres-CDs: 'single_cd_drive' oder 'multi_cd_drive'
DRIVE='single_cd_drive'

# Bei DRIVE='single_cd_drive' Angaben fuer alles CDs: 
# DIRLOC = Lokales Directory an das das html-Directory der CD-ROMs
#          gemountet oder gelinkt wird
# DIRWWW = Verzeichnisname relativ zu DocumentRoot
#	   Bei ACCESS='file:' sollte das identisch zu DIRLOC sein
# DIRIDX = Lokales Directory das den zugehoerigen glimpse-Index enthaelt
#	   Wenn hier kein Index gefunden wird, wird nur agrep benutzt.
# Alle Verzeichnisnamen mit angehaengtem '/' schreiben. 
DIRLOC=/home/www-data/ct/cdrom/
DIRWWW=/home/www-data/ct/cdrom/
DIRIDX=/home/www-data/ct/

# Bei DRIVE='multi_cd_drive' Angaben fuer einzelne Jahres-CDs:
# (Bei 'single_cd_drive' werden die folgenden Eintraege ignoriert.)
# CD-ROM 90/91
DIRLOC91=/home/www-data/ct/cdrom/
DIRWWW91=/home/www-data/ct/cdrom/
DIRIDX91=/home/www-data/ct/glimpse91/
# CD-ROM 92/93
DIRLOC93=/home/www-data/ct/cdrom/
DIRWWW93=/home/www-data/ct/cdrom/
DIRIDX93=/home/www-data/ct/glimpse93/
# CD-ROM 94
DIRLOC94=/home/www-data/ct/cdrom/
DIRWWW94=/home/www-data/ct/cdrom/
DIRIDX94=/home/www-data/ct/glimpse94/
# CD-ROM 95
DIRLOC95=/home/www-data/ct/cdrom/
DIRWWW95=/home/www-data/ct/cdrom/
DIRIDX95=/home/www-data/ct/glimpse95/
# CD-ROM 96
DIRLOC96=/home/www-data/ct/cdrom/
DIRWWW96=/home/www-data/ct/cdrom/
DIRIDX96=/home/www-data/ct/glimpse96/
# CD-ROM 97
DIRLOC97=/home/www-data/ct/cdrom/
DIRWWW97=/home/www-data/ct/cdrom/
DIRIDX97=/home/www-data/ct/glimpse97/
# CD-ROM 98
DIRLOC98=/home/www-data/ct/cdrom/
DIRWWW98=/home/www-data/ct/cdrom/
DIRIDX98=/home/www-data/ct/glimpse98/
# CD-ROM 99
DIRLOC99=/home/www-data/ct/cdrom/
DIRWWW99=/home/www-data/ct/cdrom/
DIRIDX99=/home/www-data/ct/glimpse99/
# CD-ROM 00
DIRLOC00=/home/www-data/ct/cdrom/
DIRWWW00=/home/www-data/ct/cdrom/
DIRIDX00=/home/www-data/ct/glimpse00/

# Name des System V/R4-awk-Befehls: i.a. awk oder gawk, unter SUN-OS
# und Solaris aber nawk
AWK=awk

#########################################################################
# Ab hier sind keine Anpassungen durch den Nutzer mehr noetig !
#########################################################################

# Jahresvariablen bei single_cd_drive belegen
if [ "${DRIVE}" = "single_cd_drive" ]
then
eval `for i in 91 93 94 95 96 97 98 99 00
do 
echo "DIRLOC${i}=${DIRLOC}"';'
echo "DIRWWW${i}=${DIRWWW}"';'
echo "DIRIDX${i}=${DIRIDX}glimpse${i}/"';'
done `
fi

# Header produzieren
echo 'Content-type: text/html'
echo ''

# Parameter aus dem QUERY_STRING extrahieren
eval `cgiparse -form`

# Test for cgiparse and reasonable input
if [ "${FORM_cases}" != 'nicht beachten' -a "${FORM_cases}" != 'beachten' ]
then 
echo "Der Query-String konnte durch cgiparse nicht korrekt ausgewertet werden.<p>"
echo "berprfen Sie die Installation von cgiparse und die Eingabemaske."
exit 1
fi

# HTML-Header
cat << !!
<HTML> <HEAD>
<TITLE>Ergebnis der ${SNAME}-Volltextrecherche</TITLE>
</HEAD> <BODY>
<H1 align=center>Suchergebnis: &#32;
!!

# Optionen fuer agrep entsprechend der Parameter
# Fuzzy-Variable entschaerfen
case "$FORM_fuzzy" in
0) FUZ=0; PAR='';;
*) FUZ=1; PAR='-'`echo "${FORM_fuzzy}" |sed -e 's/[^1-9]/0/g'`;;
esac
MINPAR='-i '$PAR

OTH=0
case "$FORM_cases" in
nicht?beachten) OTH=${OTH}1 ; PAR=$PAR' -i';;
esac

case "$FORM_words" in
ganze?Worte) OTH=${OTH}1 ; PAR=$PAR' -w';;
esac

#Logische Verknuepfung auswerten, Leerzeichen entsprechend ersetzen
case "${FORM_relat}" in
String)   EXPR=`echo "${FORM_suchwort}" |sed 's/ *$//'`
          WEXPR="${FORM_suchwort}" ;;
AND)      EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */;/g'`
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \& /g'` ;; 
OR)       EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */,/g'`
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \| /g'` ;;
esac
# Eine Boolsche Verknuepfung entspricht einer zusaetzlichen Option
if echo "${EXPR}" |grep -q -e '[,;]' 2>/dev/null
then OTH=${OTH}1
fi
# Suchstring fuer zweite Stufe der Reduktionssuche
MINEXP='pre\>,'`echo "${EXPR}" |  sed -e 's/;/,/g' -e 's/^\(.\{22\}\).*/\1/'`

# In der Kombination von fehlertoleranter Suche mit irgendeiner anderen
# Option machte agrep schwere Fehler bei der Delimiter-Behandlung, bei
# der Zeilenzaehlung mit -n und bei der Dateinamenausgabe mit -l !
# Hier wird -l vermieden indem es durch -c mit anschliessendem sed 
# ersetzt wird. Obwohl dies in der aktuellen Version nicht mehr noetig
# ist, wird der Delimiter < noch durch \< ersetzt.
if test `expr "${FUZ}" \* "${OTH}"` -ge 1 
then PAR=$PAR' -d \<'
else PAR=$PAR' -d <'
fi

# Ausgabe des Suchwortes im Kopf
echo "${WEXPR} </h1><hr>"

# Anzahlbegrenzung ermitteln
if ANZ=`expr "${FORM_anzahl}" - 0 2>/dev/null `; then ANZ=$ANZ; else ANZ=1000; fi

# Jahre aus Parametern bestimmen, Directories auswaehlen
J1=`expr "${FORM_jahr}" - 0`
SJ1=`echo ${J1} | cut -c '3,4'`
case $J1 in
1990|1991) DIRLOC=${DIRLOC91}${SJ1}/; DIRWWW=${DIRWWW91}${SJ1}/; DIRIDX=${DIRIDX91} ;;
1992|1993) DIRLOC=${DIRLOC93}${SJ1}/; DIRWWW=${DIRWWW93}${SJ1}/; DIRIDX=${DIRIDX93} ;;
1994) DIRLOC=${DIRLOC94}; DIRWWW=${DIRWWW94}; DIRIDX=${DIRIDX94} ;;
1995) DIRLOC=${DIRLOC95}${SJ1}/; DIRWWW=${DIRWWW95}${SJ1}/; DIRIDX=${DIRIDX95} ;;
1996) DIRLOC=${DIRLOC96}${SJ1}/; DIRWWW=${DIRWWW96}${SJ1}/; DIRIDX=${DIRIDX96} ;;
1997) DIRLOC=${DIRLOC97}${SJ1}/; DIRWWW=${DIRWWW97}${SJ1}/; DIRIDX=${DIRIDX97} ;;
1998) DIRLOC=${DIRLOC98}${SJ1}/; DIRWWW=${DIRWWW98}${SJ1}/; DIRIDX=${DIRIDX98} ;;
1999) DIRLOC=${DIRLOC99}${SJ1}/; DIRWWW=${DIRWWW99}${SJ1}/; DIRIDX=${DIRIDX99} ;;
*) DIRLOC=${DIRLOC00}${SJ1}/; DIRWWW=${DIRWWW00}${SJ1}/; DIRIDX=${DIRIDX00} ;;
esac

# Monate numerisch und sicher machen, sortieren
if echo "${FORM_monat}" | grep -q -e "alle" 2>/dev/null
then
MONAT='01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26'
else
MONAT=`echo '0'"${FORM_monat}" | sed -e 's/[^0-9,]//g' -e 's/,/,0/g' -e 's/0\([1-9][0-9]\)/\1/g' -e 's/,/ /g'`
MONAT=`for i in ${MONAT}; do echo $i; done |sort`
fi

# Heft-Directory scannen - Liste von Dateinamen erstellen.
# Arbeit mit glimpse. Falls kein glimpse-Index vorhanden ist,
# wird agrep auf alle Artikel-Dateien angewendet
if test -r ${DIRIDX}.glimpse_index 
then
# Folge von Suchmustern fuer die glimpse-Dateinamen konstruieren
# Da das F-Feld von glimpse nur 256 Zeichen enthalten darf, sollte 
# ein kurzer Unterscheidungspfad gewaehlt werden -> groessten gemeinsamen
# Pfad abtrennen (Damit kann ein gemeinsamer Index benutzt werden).
DIRCOMN=`echo ${DIRLOC} |\
$AWK -F'/' '{ MAX=NF-2; for (i=2;i<=MAX;i++) printf("/%s",$i); printf("\n") }'`
DIRDIFF=`echo ${DIRLOC} | sed -e 's:'${DIRCOMN}'::'`

# glimpse kann nur 16 Ausdrcke per OR verknuepfen - Workaround
if  [ 16 -ge `echo ${MONAT} |wc -w` ]
then
TREE=`echo ${MONAT} | sed -e 's:[012][0-9]:'${DIRDIFF}'&/:g' -e 's:/ :/,:g'`
FPAR='-F '"${TREE}"
else
# Nur zusammenhaengende Bereiche
FRSTM=`echo ${MONAT} | sed -e 's/^.//' -e 's/ .*$//'`
LASTM=`echo ${MONAT} |sed -e 's/^.* .//'`
if echo ${MONAT} | grep -q -e '^0' 2>/dev/null; then FPATH='0[1-9]'; fi
if echo ${MONAT} | grep -q -e ' 1' 2>/dev/null; then FPATH=${FPATH}' 1[0-9]'; fi
if echo ${MONAT} | grep -q -e ' 2' 2>/dev/null; then FPATH=${FPATH}' 2[0-6]'; fi
TREE=`echo ${FPATH} | sed -e 's/\[./\['${FRSTM}'/' -e 's/.\]$/'${LASTM}'\]/' \
  	-e 's:[012]\[.-.\]:'${DIRDIFF}'&/:g' -e 's:/ :/,:g'`
FPAR='-F '"${TREE}"
MONAT=`echo ${MONAT} | sed -e 's/ .* /-/'`
fi

# Eigentliche Suche nach den relevanten Dateien.
FULLLIST=`glimpse -c -y $PAR $FPAR -H $DIRIDX -e "${EXPR}" 2>/dev/null | sed 's/: .*$//'`
else
TREE=`echo ${MONAT} | sed -e 's:[012][0-9]:'${DIRLOC}'&/*/art*.htm:g'`
FULLLIST=`agrep -c $PAR -e "${EXPR}" $TREE 2>/dev/null |\
sed -e 's/^.*: 0$//' -e 's/: .*$//' `
fi

# Anzahl ermitteln/begrenzen
TOT=`echo ${FULLLIST} | wc -w`
FULLLIST=`echo $FULLLIST |cut -d ' ' -f 1-${ANZ}`

# Titel und Textstellen heraussuchen
# Fuer Titelzeile und Suchwort sind zwei Durchgaenge noetig, um im
# fehlertoleranten Fall die Worterkennung nicht durch einen Boolschen
# Ausdruck zu opfern, einzelne Hervorhebungen werden ignoriert.
for i in $FULLLIST
do 
echo '{{h3}}'$i ;
agrep -d '<' -i '\<title\>' $i 2>/dev/null ; echo '{{p}}'
sed -e 's/<\/*[bBiI]>//g' $i |agrep $PAR -e "${EXPR}" 2>/dev/null |\
agrep $MINPAR -d '$$' "${MINEXP}" 2>/dev/null ;
echo '' ; echo '{{p}}{{hr}}'
done |\

# Nachbearbeitung mit sed und awk
# Doppelbenutzung ist ineffektiv aber einfachste Loesung (spaeter verbessern)
sed -e 's/<[Tt][Ii][Tt][Ll][Ee]>/\
{{h2}}/g'  -e 's/<[Pp][Rr][Ee]>/\
{{pre}}/g' -e 's/<[^>]*>/\
{{p}}/g' -e 's/{{/</g' -e 's/}}/>/g' |\

# Manche awk Versionen haben eine Feldzahlbegrenzung.
# Bei Problemen kann diese durch einen anderen Delimiter umgangen werden.
$AWK  '	BEGIN  { LAST="" }
	/</    { LLAST="</"substr($0,index($0,"<")+1,index($0,">")-1);
		 $0=LAST$0;
		 LAST=LLAST }
	/<h3>/ { FNAME=$0;
		 nn=gsub("<h3>'$DIRLOC'","<h3><a href=\"'${ACCESS}${DIRWWW}'",$0);
		 nn=gsub("^.*<h3>'$DIRSUB'","",FNAME);
		 nn=split(FNAME,NUMB,"/");
		 printf("%s\">'${FNAME}' '${J1}', Heft %d, Seite %d </a>", $0,NUMB[nn-2],NUMB[nn-1]);
		 nn=gsub(".*","",$0) }
              { print } '

MONAT=`echo $MONAT | sed -e 's: :,:g' -e 's/^0//' -e 's/,0/,/g'`
echo "<h2 align=center>Begriff in ${TOT} Artikeln der ${FNAME} ${MONAT}/${J1} gefunden. </h2>"
echo '<p><hr>'

# Kontrollausgabe der Input-Parameter
echo "<strong>Benutzte Parameter:</strong> Gro/Kleinschreibung ${FORM_cases}, bereinstimmung: ${FORM_words}, ${FORM_fuzzy} Fehler, Wortverknpfung: ${FORM_relat},"
echo "Fundstellenausgabe: ${FORM_anzahl}.<hr><p>"

echo "</BODY></HTML>"
# Das wars schon.

